'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _d3Axis = require('d3-axis');

var D3Axis = _interopRequireWildcard(_d3Axis);

var _d3Selection = require('d3-selection');

var D3Selection = _interopRequireWildcard(_d3Selection);

var _reactFauxDom = require('react-faux-dom');

var _reactFauxDom2 = _interopRequireDefault(_reactFauxDom);

var _Scale = require('../utils/Scale');

var _Scale2 = _interopRequireDefault(_Scale);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Axis = function (_Component) {
	_inherits(Axis, _Component);

	function Axis() {
		_classCallCheck(this, Axis);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(Axis).apply(this, arguments));
	}

	_createClass(Axis, [{
		key: '_mkTickAxis',
		value: function _mkTickAxis() {
			var _props = this.props;
			var tickOrient = _props.tickOrient;
			var tickFormat = _props.tickFormat;
			var tickPadding = _props.tickPadding;
			var innerTickSize = _props.innerTickSize;
			var ticks = _props.ticks;


			var func = D3Axis;

			if (tickOrient === 'left') {
				func = func.axisLeft(this._mkScale(this.props));
			} else if (tickOrient === 'right') {
				func = func.axisRight(this._mkScale(this.props));
			} else if (tickOrient === 'top') {
				func = func.axisTop(this._mkScale(this.props));
			} else if (tickOrient === 'bottom') {
				func = func.axisBottom(this._mkScale(this.props));
			}

			func.orient(tickOrient);
			func.tickFormat(tickFormat);
			func.tickPadding(tickPadding);
			func.innerTickSize(innerTickSize);
			func.ticks.apply(null, ticks);

			return func;
		}
	}, {
		key: '_mkScale',
		value: function _mkScale() {
			return (0, _Scale2.default)(this.props);
		}
	}, {
		key: '_axisClassName',
		value: function _axisClassName(type) {

			if (type === 'x') {
				return this.props.axisClassName + ' axis x';
			} else if (type === 'y') {
				return this.props.axisClassName + ' axis y';
			} else if (type === 'gridx' || type === 'gridy') {
				return this.props.gridAxisClassName + ' grid-axis';
			}

			return null;
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props;
			var showAxis = _props2.showAxis;
			var type = _props2.type;
			var style = _props2.style;


			var axisGroup = _reactFauxDom2.default.createElement('g');
			var axisClasses = this._axisClassName(type);

			axisGroup.setAttribute('class', axisClasses);
			var axisDom = D3Selection.select(axisGroup);

			axisDom.call(this._mkTickAxis());

			if (!showAxis) {

				axisDom.selectAll('.grid-axis .tick text').style('opacity', '0');

				if (type === 'gridx' || type === 'gridy') {

					axisDom.selectAll('.grid-axis .domain').style('opacity', '0');
				}
			}

			// basic styles
			axisDom.selectAll('.axis path').style('stroke', '#000').style('shape-rendering', 'crispEdges');

			axisDom.selectAll('.axis line').style('stroke', '#e7e7e7').style('shape-rendering', 'crispEdges');

			axisDom.selectAll('.grid-axis line').style('stroke', '#000').style('opacity', 0.2).style('stroke-width', '1px');

			axisDom.selectAll('.axis path').style('display', 'none');

			var axisText = axisDom.selectAll('.axis text');

			axisText.style('fill', '#454545').style('font-size', 12);

			if (style) {

				for (var key in style) {

					if (style[key]) {
						axisText.style(key, style[key]);
					}
				}
			}

			return axisDom.node().toReact();
		}
	}]);

	return Axis;
}(_react.Component);

Axis.defaultProps = {
	range: null,
	rangeRoundBands: null,
	domain: null,
	tickFormat: null,
	tickOrient: null
};

Axis.propTypes = {
	showAxis: _react.PropTypes.bool,
	type: _react.PropTypes.string,
	orient: _react.PropTypes.oneOf(['top', 'bottom', 'left', 'right']),
	tickOrient: _react.PropTypes.oneOf(['top', 'bottom', 'left', 'right'])
};

exports.default = Axis;