'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Axis = require('./Axis');

var _Axis2 = _interopRequireDefault(_Axis);

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _CoreCommonProps = require('../utils/CoreCommonProps');

var _CoreCommonProps2 = _interopRequireDefault(_CoreCommonProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var XAxis = function (_Component) {
	_inherits(XAxis, _Component);

	function XAxis() {
		_classCallCheck(this, XAxis);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(XAxis).apply(this, arguments));
	}

	_createClass(XAxis, [{
		key: 'render',
		value: function render() {
			var t = void 0;
			var axisLabel = void 0;
			var _props = this.props;
			var height = _props.height;
			var width = _props.width;
			var margins = _props.margins;
			var showXAxis = _props.showXAxis;
			var x = _props.x;
			var xAxisClassName = _props.xAxisClassName;
			var xDomain = _props.xDomain;
			var xRange = _props.xRange;
			var xRangeRoundBands = _props.xRangeRoundBands;
			var xScale = _props.xScale;
			var xOrient = _props.xOrient;
			var xTickOrient = _props.xTickOrient;
			var xTickPadding = _props.xTickPadding;
			var xInnerTickSize = _props.xInnerTickSize;
			var xOuterTickSize = _props.xOuterTickSize;
			var xTickFormat = _props.xTickFormat;
			var xTicks = _props.xTicks;
			var xLabel = _props.xLabel;
			var xLabelPosition = _props.xLabelPosition;
			var labelOffset = _props.labelOffset;
			var style = _props.style;


			if (!xRange) {
				xRange = [0, width - margins.left - margins.right];
			}

			if (xOrient === 'bottom') {
				// x - bottom
				t = 'translate(0, ' + (height - margins.bottom - margins.top) + ')';
			} else if (xOrient === 'top') {
				// x - top
				t = 'translate(0, 0)';
			}

			if (xLabel) {
				axisLabel = _react2.default.createElement(_Label2.default, {
					height: height,
					width: width,
					margins: margins,
					labelTitle: xLabel,
					labelPosition: xLabelPosition,
					labelOffset: labelOffset,
					rangeRoundBands: xRangeRoundBands
				});
			}

			return _react2.default.createElement(
				'g',
				{ className: 'x-axis', transform: t },
				_react2.default.createElement(_Axis2.default, {
					height: height,
					width: width,
					margins: margins,
					showAxis: showXAxis,
					axisClassName: xAxisClassName,
					rangeRoundBands: xRangeRoundBands,
					type: 'x',
					proxy: x,
					domain: xDomain,
					range: xRange,
					scale: xScale,
					orient: xOrient,
					tickOrient: xTickOrient,
					tickFormat: xTickFormat,
					tickPadding: xTickPadding,
					innerTickSize: xInnerTickSize,
					outerTickSize: xOuterTickSize,
					ticks: xTicks,
					style: style
				}),
				axisLabel
			);
		}
	}]);

	return XAxis;
}(_react.Component);

XAxis.propTypes = {
	height: _react.PropTypes.number.isRequired,
	width: _react.PropTypes.number.isRequired,
	margins: _react.PropTypes.object.isRequired,
	showXAxis: _react.PropTypes.bool,
	x: _react.PropTypes.func,
	xDomain: _react.PropTypes.array,
	xRange: _react.PropTypes.array,
	xScale: _react.PropTypes.string.isRequired,
	xOrient: _react.PropTypes.oneOf(['top', 'bottom']),
	xTickOrient: _react.PropTypes.oneOf(['top', 'bottom']),
	xAxisClassName: _react.PropTypes.string,
	xInnerTickSize: _react.PropTypes.number,
	xOuterTickSize: _react.PropTypes.number,
	xTickPadding: _react.PropTypes.number,
	xTickFormat: _react.PropTypes.func,
	xTicks: _react.PropTypes.array,
	style: _react.PropTypes.object
};

XAxis.defaultProps = Object.assign(_CoreCommonProps2.default, {
	showXAxis: true,
	xAxisClassName: 'axis axis--x',
	xScale: 'linear',
	xOrient: 'bottom',
	xTickOrient: 'bottom',
	xLabelPosition: 'bottom',
	xTickPadding: 3,
	xInnerTickSize: 6,
	xOuterTickSize: 0
});

exports.default = XAxis;