'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Axis = require('./Axis');

var _Axis2 = _interopRequireDefault(_Axis);

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _CoreCommonProps = require('../utils/CoreCommonProps');

var _CoreCommonProps2 = _interopRequireDefault(_CoreCommonProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YAxis = function (_Component) {
	_inherits(YAxis, _Component);

	function YAxis() {
		_classCallCheck(this, YAxis);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(YAxis).apply(this, arguments));
	}

	_createClass(YAxis, [{
		key: 'render',
		value: function render() {
			var t = void 0;
			var axisLabel = void 0;
			var _props = this.props;
			var width = _props.width;
			var height = _props.height;
			var margins = _props.margins;
			var y = _props.y;
			var yAxisClassName = _props.yAxisClassName;
			var yDomain = _props.yDomain;
			var yRange = _props.yRange;
			var yRangeRoundBands = _props.yRangeRoundBands;
			var yScale = _props.yScale;
			var yOrient = _props.yOrient;
			var yTickOrient = _props.yTickOrient;
			var yTickFormat = _props.yTickFormat;
			var yTickPadding = _props.yTickPadding;
			var yInnerTickSize = _props.yInnerTickSize;
			var yOuterTickSize = _props.yOuterTickSize;
			var yTicks = _props.yTicks;
			var yLabel = _props.yLabel;
			var yLabelPosition = _props.yLabelPosition;
			var labelOffset = _props.labelOffset;
			var showYAxis = _props.showYAxis;
			var style = _props.style;


			if (!yRange) {
				yRange = [height - margins.top - margins.bottom, 0];
			}

			if (yOrient === 'right') {
				// y - right
				t = 'translate(' + (width - margins.right - margins.left) + ', 0)';
			} else if (yOrient === 'left') {
				// y - left
				t = 'translate(0, 0)';
			}

			if (yLabel) {
				axisLabel = _react2.default.createElement(_Label2.default, {
					height: height,
					width: width,
					margins: margins,
					labelTitle: yLabel,
					labelPosition: yLabelPosition,
					labelOffset: labelOffset
				});
			}

			return _react2.default.createElement(
				'g',
				{ className: 'y-axis', transform: t },
				_react2.default.createElement(_Axis2.default, {
					height: height,
					width: width,
					margins: margins,
					showAxis: showYAxis,
					axisClassName: yAxisClassName,
					rangeRoundBands: yRangeRoundBands,
					type: 'y',
					proxy: y,
					domain: yDomain,
					range: yRange,
					scale: yScale,
					orient: yOrient,
					tickOrient: yTickOrient,
					tickFormat: yTickFormat,
					tickPadding: yTickPadding,
					innerTickSize: yInnerTickSize,
					outerTickSize: yOuterTickSize,
					ticks: yTicks,
					style: style
				}),
				axisLabel
			);
		}
	}]);

	return YAxis;
}(_react.Component);

YAxis.propTypes = {
	height: _react.PropTypes.number.isRequired,
	width: _react.PropTypes.number.isRequired,
	margins: _react.PropTypes.object.isRequired,
	showXAxis: _react.PropTypes.bool,
	y: _react.PropTypes.func,
	yDomain: _react.PropTypes.array,
	yRange: _react.PropTypes.array,
	yScale: _react.PropTypes.string.isRequired,
	yOrient: _react.PropTypes.oneOf(['left', 'right']),
	yTickOrient: _react.PropTypes.oneOf(['left', 'right']),
	yAxisClassName: _react.PropTypes.string,
	yInnerTickSize: _react.PropTypes.number,
	yOuterTickSize: _react.PropTypes.number,
	yTickPadding: _react.PropTypes.number,
	yTickFormat: _react.PropTypes.func,
	yTicks: _react.PropTypes.array,
	style: _react.PropTypes.object
};

YAxis.defaultProps = Object.assign(_CoreCommonProps2.default, {
	showYAxis: true,
	yAxisClassName: 'axis axis--y',
	yScale: 'linear',
	yOrient: 'left',
	yTickOrient: 'left',
	yLabelPosition: 'left',
	yTickPadding: 20,
	yInnerTickSize: 0,
	yOuterTickSize: 0
});

exports.default = YAxis;