'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Axis = require('../axis/Axis');

var _Axis2 = _interopRequireDefault(_Axis);

var _CoreCommonProps = require('../utils/CoreCommonProps.js');

var _CoreCommonProps2 = _interopRequireDefault(_CoreCommonProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Grid = function (_Component) {
	_inherits(Grid, _Component);

	function Grid() {
		_classCallCheck(this, Grid);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(Grid).apply(this, arguments));
	}

	_createClass(Grid, [{
		key: 'render',
		value: function render() {
			var type = this.props.type;
			var gridAxis = void 0;
			var t = void 0;
			var _props = this.props;
			var height = _props.height;
			var width = _props.width;
			var margins = _props.margins;
			var gridAxisClassName = _props.gridAxisClassName;
			var xRangeRoundBands = _props.xRangeRoundBands;
			var x = _props.x;
			var xDomain = _props.xDomain;
			var xRange = _props.xRange;
			var xScale = _props.xScale;
			var yRangeRoundBands = _props.yRangeRoundBands;
			var y = _props.y;
			var yDomain = _props.yDomain;
			var yRange = _props.yRange;
			var yScale = _props.yScale;


			if (!yRange) {
				yRange = [height - margins.top - margins.bottom, 0];
			}

			if (!xRange) {
				xRange = [0, width];
			}

			if (type === 'x') {
				t = 'translate(0, ' + (height - margins.bottom - margins.top) + ')';
				var tickSize = height;

				// if grid axis don't pass customize ticks.
				gridAxis = _react2.default.createElement(_Axis2.default, {
					className: 'x-grid',
					height: height,
					width: width,
					margins: margins,
					type: 'gridx',
					showAxis: false,
					gridAxisClassName: gridAxisClassName,
					rangeRoundBands: xRangeRoundBands,
					tickOrient: 'bottom',
					orient: 'bottom',
					outerTickSize: 0,
					tickPadding: 0,
					tickFormat: null,
					innerTickSize: -tickSize,
					proxy: x,
					domain: xDomain,
					range: xRange,
					scale: xScale
				});
			} else if (type === 'y') {

				t = 'translate(0, 0)';
				var _tickSize = width;

				// if grid axis don't pass customize ticks.
				gridAxis = _react2.default.createElement(_Axis2.default, {
					className: 'y-grid',
					height: height,
					width: width,
					margins: margins,
					type: 'gridy',
					showAxis: false,
					gridAxisClassName: gridAxisClassName,
					rangeRoundBands: yRangeRoundBands,
					tickOrient: 'left',
					orient: 'left',
					outerTickSize: 0,
					tickPadding: 0,
					innerTickSize: -_tickSize,
					tickFormat: null,
					proxy: y,
					scale: yScale,
					domain: yDomain,
					range: yRange
				});
			}

			return _react2.default.createElement(
				'g',
				{ transform: t },
				gridAxis
			);
		}
	}]);

	return Grid;
}(_react.Component);

Grid.defaultProps = Object.assign(_CoreCommonProps2.default, {
	type: 'x',
	gridAxisClassName: 'grid-axis',
	xScale: 'linear',
	yScale: 'linear'
});

Grid.propTypes = {
	height: _react.PropTypes.number.isRequired,
	width: _react.PropTypes.number.isRequired,
	margins: _react.PropTypes.object.isRequired,
	type: _react.PropTypes.oneOf(['x', 'y']).isRequired,
	gridAxisClassName: _react.PropTypes.string,
	x: _react.PropTypes.func,
	xDomain: _react.PropTypes.array,
	xRange: _react.PropTypes.array,
	xScale: _react.PropTypes.oneOf(['linear', 'identity', 'sqrt', 'pow', 'log', 'quantize', 'quantile', 'ordinal', 'time']).isRequired,
	xRangeRoundBands: _react.PropTypes.object,
	y: _react.PropTypes.func,
	yDomain: _react.PropTypes.array,
	yRange: _react.PropTypes.array,
	yScale: _react.PropTypes.oneOf(['linear', 'identity', 'sqrt', 'pow', 'log', 'quantize', 'quantile', 'ordinal', 'time']).isRequired,
	yRangeRoundBands: _react.PropTypes.object
};

exports.default = Grid;