'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.xDomain = xDomain;

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _d3Array = require('d3-array');

var D3Array = _interopRequireWildcard(_d3Array);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function xDomain(props, stack, horizonal) {

	var _xDomain = props.xDomain;

	var data = props.data;
	var chartSeries = props.chartSeries;
	var x = props.x;
	var xScale = props.xScale;


	if (_xDomain) {
		return _xDomain;
	}

	if (!horizonal) {
		if (xScale === 'ordinal') {
			return data.map(function (d) {
				return x(d);
			});
		} else {
			return D3Array.extent(data, function (d) {
				return x(d);
			});
		}
	} else {
		if (stack) {
			var _ret = function () {
				// stack
				var max = 0,
				    min = 0;

				data.forEach(function (d) {
					var totalTop = 0,
					    totalBottom = 0;

					chartSeries.forEach(function (sd) {
						var field = sd.field;

						if (d[field] > 0) {
							totalTop += x(d[field]);
						} else if (d[field] < 0) {
							totalBottom += x(d[field]);
						}
					});

					if (totalTop > max) max = totalTop;
					if (totalBottom < min) min = totalBottom;
				});

				return {
					v: [min, max]
				};
			}();

			if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
		} else {

			// not stack, single
			var domainArr = chartSeries.map(function (d) {
				var field = d.field;
				var extent = D3Array.extent(data, function (dt) {
					return x(dt[field]);
				});

				return extent;
			});

			return D3Array.extent([].concat.apply([], domainArr));
		}
	}
}