'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.yDomain = yDomain;

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _d3Array = require('d3-array');

var D3Array = _interopRequireWildcard(_d3Array);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function yDomain(props, stack, horizontal) {

	var _yDomain = props.yDomain;

	var data = props.data;
	var chartSeries = props.chartSeries;
	var y = props.y;


	if (_yDomain) {
		return _yDomain;
	}

	if (!horizontal) {
		if (stack) {
			var _ret = function () {

				var max = 0,
				    min = 0;

				data.forEach(function (d) {

					var totalTop = 0,
					    totalBottom = 0;

					chartSeries.forEach(function (sd) {
						var field = sd.field;

						if (d[field] > 0) {
							totalTop += y(d[field]);
						} else if (d[field] < 0) {
							totalBottom += y(d[field]);
						}
					});

					if (totalTop > max) max = totalTop;
					if (totalBottom < min) min = totalBottom;
				});

				return {
					v: [min, max]
				};
			}();

			if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
		} else {
			// not stack, single
			var domainArr = chartSeries.map(function (d) {

				var field = d.field;
				var extent = D3Array.extent(data, function (dt) {
					return y(dt[field]);
				});

				return extent;
			});

			return _d2.default.extent([].concat.apply([], domainArr));
		}
	} else {

		return D3Array.extent(data, function (d) {
			return y(d);
		});
	}
}